; Q3SA - a mIRC addon for Quake 3
; Copyright () 2001, Andy Uhl
; email: monk@demoxpress.com

; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

menu channel,query,menubar,status {
    -
    Q3SA: Q3SA.start
}

; calls mdx dll
alias -l mdx {
    var %dll = $shortfn($scriptdir) $+ mdx.dll
    return $dll(%dll,$1,$2-)
}

; main dialog window
dialog Q3SA.dialog {
    size    -1 -1 520 482
    option  type pixels

    button  "OK", 500, -1 -1 5 5, ok hide disable
    button  "Cancel", 550, -1 -1 5 5, cancel hide disable
    button  "Ping", 501, -1 -1 5 5, default hide
    edit    ""    , 313, -1 -1 5 5, read hide
    edit    ""    , 314, -1 -1 5 5, read hide

    box     "Server Info", 100, 10 10 244 246

    edit    "", 300, 22 28 220 18, enter center autohs
    edit    "", 301, 22 50 220 18, read center autohs

    text    "ping"   , 400,  22 70  40 14, center
    edit    ""       , 303,  22 84  40 18, read center
    text    "map"    , 401,  72 70 120 14, center
    edit    ""       , 304,  72 84 120 18, read center
    text    "private", 409, 202 70  40 14, center
    edit    ""       , 312, 202 84  40 18, read center

    text    "passwords", 405, 22 105 220 14, center
    combo   600, 22 119 220 150, edit drop vsbar size disable

    text    "gametype", 402, 22 142 104 14, center
    edit    ""        , 305, 22 156 104 18, read center

    text    "gamename", 404, 138 142 104 14, center
    edit    ""        , 307, 138 156 104 18, read center

    text    "time/frag/cap limit", 403, 22 176 104 14, center
    edit    ""                   , 306, 22 190 104 18, read center

    text    "players/private/max", 406, 138 176 104 14, center
    edit    ""                   , 309, 138 190 104 18, read center

    text    "team game info", 407, 22 210 220 14, center
    edit    ""         , 310, 22 224 220 18, read center

    box     "Players", 101, 266 10 244 246
    radio   "All"   , 700, 279 28 54 20, push group
    radio   "Blue"  , 701, 333 28 55 20, push disable
    radio   "Red"   , 702, 388 28 55 20, push disable
    radio   "Spec"  , 703, 443 28 54 20, push disable

    list    201, 278 55 220 188, sort size extsel
    list    203, 278 55 220 188, sort size extsel hide
    list    204, 278 55 220 188, sort size extsel hide
    list    205, 278 55 220 188, sort size extsel hide

    button  "Refresh"        , 502,  11 267 70 24, disable
    check   "Play"           , 507,  91 267 70 24, push disable
    button  "Copy"           , 504, 171 267 70 24, disable
    button  "Report"         , 513, 251 267 70 24, disable
    check   "Favorite"       , 580, 331 267 70 24, push disable

    box     "Favorites", 102, 10 297 500 155
    list    202, 22 315 476 124, sort size extsel
    combo   601, 414 269 95 150, vsbar drop

    menu    "&Q3SA"                     , 1100
    item    "&Options..."               , 511
    ;item    "&Grouping..."              , 1101
    item    break                       , 1102
    item    "&Check for updates..."     , 1103
    item    break                       , 1104
    item    "&Quit"                     , 1105

    menu    "&Server"                   , 1110
    item    "&Play"                     , 1111
    item    break                       , 1112
    item    "&Refresh"                  , 1113
    item    "&Monitor"                  , 503
    item    break                       , 1115
    item    "&Info..."                  , 506
    item    "&Copy"                     , 1117
    item    "Re&port"                   , 1118
    item    break                       , 1119
    item    "&Add Favorite"             , 509
    item    "&Remove Favorite"          , 510
    item    break                       , 1120
    item    "Add to Current Group"      , 1121
    item    "Remove from Current Group" , 1122

    menu    "&About"                    , 1130
    ;item    "&Contents..."              , 1131
    ;item    "&Index..."                 , 1132
    ;item    "&Search..."                , 1133
    ;item    break                       , 1134
    item    "&About Q3SA..."            , 1135
    item    "About vPak..."             , 1136
    item    break                       , 1137
    item    "Q3SA License..."           , 1138

    box     "", 1150, -5 -6 530 525
}

; server info dialog
dialog Q3SA.server_info_dialog {
    title   "Server Info"
    size    -1 -1 400 204
    option  type pixels

    list    200, 10 10 380 151, sort extsel size
    button  "OK", 500, 160 170 80 24, ok default
}

; options dialog
dialog Q3SA.options_dialog {
    title   "Q3SA Options"
    size    -1 -1 200 143
    option  type dbu

    list    1, 5 5 60 139

    button  "OK"    , 2,  70 125 35 12, ok default
    button  "Cancel", 3, 115 125 35 12, cancel
    button  "Apply" , 4, 160 125 35 12, disable

    ; Copy and Paste
    box     "Copy and Paste format", 400, 70  5 125 79
    radio   "Q3SA Standard"        , 406, 77 13 112 12, group
    radio   "Arena Scout"          , 401, 77 23 112 12
    radio   "Q3P"                  , 402, 77 33 112 12
    radio   "zSpy"                 , 403, 77 43 112 12
    radio   "Custom"               , 404, 77 53 112 12
    edit    ""                     , 405, 76 65 113 12, read autohs

    ; Groups
    box     "Groups", 500,  70  5 125 113, hide
    list              501,  76 14 113  78, hide size extsel
    button  "Add...", 502,  95 98  35  12, hide
    button  "Remove", 503, 135 98  35  12, hide

    ; IRC
    box     "When joining a server"     , 100, 70  5 125 102, hide
    check   "Set IRC name on connect"   , 101, 77 13 112  12, hide
    edit    ""                          , 102, 76 25 113  12, read autohs hide
    check   "Set away on connect"       , 105, 77 39 112  12, hide
    edit    ""                          , 106, 76 51 113  12, read autohs hide
    check   "Announce connection"       , 103, 77 65 112  12, hide
    edit    ""                          , 104, 76 77 113  12, read autohs hide
    check   "Add Q3SA 'ctcp version' response" , 107, 77 91 112  12, hide


    ; Miscellaneous
    box     "Password warnings"                 , 200,  70  5 125 35, hide
    check   "Warn if join password required"    , 201,  77 13 112 12, hide
    check   "Warn if priority password required", 202,  77 25 112 12, hide
    box     "Initial window parent"             , 203,  70 44 125 23, hide
    radio   "Desktop"                           , 204,  77 52  50 12, hide group iwp
    radio   "mIRC"                              , 205, 127 52  50 12, hide
    box     "Server Refresh"                    , 206,  70 71 125 43, hide
    text    "Refresh Interval:"                 , 207,  77 83  40 12, hide
    edit    ""                                  , 208, 121 81  20 12, autohs hide
    text    "Timeout value:"                    , 209,  77 97  40 12, hide
    edit    ""                                  , 210, 121 95  20 12, autohs hide
    text    "(in seconds)"                      , 211, 145 83  40 12, hide
    text    "(in milliseconds)"                 , 212, 145 97  40 12, hide

    ; Quake 3 Setup
    box     "Quake 3"                       , 300,  70  5 125 112, hide
    text    "Quake 3 Executable"            , 301,  77 15 125  11, hide
    edit    ""                              , 302,  76 23  75  12, autohs hide
    button  "Browse..."                     , 303, 156 23  32  12, hide
    check   "Execute config file"           , 304,  77 37 125  11, hide
    edit    ""                              , 305,  76 48  75  12, autohs read hide
    button  "Browse..."                     , 306, 156 48  32  12, disable hide
    check   "Set Quake 3 name"              , 307,  77 62  60  11, hide
    edit    ""                              , 308,  76 73 113  12, autohs read hide
    check   "Set other command line options", 309,  77 87 110  11, hide
    edit    ""                              , 310,  76 98 113  12, autohs read hide
}


dialog Q3SA.about_dialog {
    size    -1 -1 200 150
    option  type pixels

    text    "", 1, 10 10 180 90
    button  "OK", 2, 75 110 50 30, ok default
}

dialog Q3SA.download_dialog {
    size    -1 -1 375 233
    title   "Download Q3SA"

    button  "", 1,  0  0 375 60

    text    "Saving:", 3, 10 70 40 13
    text    "", 4, 10 85 355 13

    text    "", 5, 10 104 355 13

    text    "Download to:", 6, 10 125 90 13
    text    "Estimated time left:", 7, 10 141 90 13
    text    "File size:", 8, 10 157 90 13
    text    "Transfer Rate:", 9, 10 173 90 13

    text    "", 10, 105 125 260 13
    text    "", 11, 105 141 265 13
    text    "", 12, 105 157 265 13
    text    "", 13, 105 173 265 13

    button  "Cancel"    , 14, 290 200 75 23, cancel
    button  "Install"   , 15, 205 200 75 23, disable
    button  "Close"     , 16, 290 200 75 23, ok hide
}

dialog Q3SA.
; adds the current server to the favorites list if it doesn't already exist
alias -l Q3SA.add_favorite {
    ; check for valid address
    if ($Q3SA.is_valid_address($did(Q3SA.dialog, 300))) {
        ; make it a full address and replace the ip input line with the full address
        var %address = $Q3SA.make_full_address($did(Q3SA.dialog,300))
        did -ra Q3SA.dialog 300 %address
        ; if it's not already a favorite
        if (!$Q3SA.is_favorite(%address)) {
            ; write to the ini, update the favorites listbox, switch Add Favorites to Remove Favorites
            if ((%Q3SA.current_group == $null) || (%Q3SA.current_group == <All>) || (%Q3SA.current_group == <Unassigned>)) {
                writeini %Q3SA.ini favorites %address $infostring(0,$did(Q3SA.dialog, 301))
            }
            else {
                writeini %Q3SA.ini favorites %address $infostring(0,$did(Q3SA.dialog, 301),%Q3SA.current_group)
            }
            did -a Q3SA.dialog 202 $tab(+ 0 0 0 0,+ 0 0 0 $did(Q3SA.dialog, 301),+ 0 0 0 %address)
            did -b Q3SA.dialog 509,1121
            did -e Q3SA.dialog 510,1122
            did -c Q3SA.dialog 580
        }
    }
}

; undo any state changes caused by Q3SA when joining a server
alias Q3SA.back {
    ; if your nick was changed, set it back to what it was
    if ($readini(%Q3SA.ini,n,main,set_irc_name) == 1) { nick %Q3SA.original_nick }
    ; if you were set away, mark you as being back
    if ($away && ($readini(%Q3SA.ini,n,main,set_away) == 1)) { away }
    did -u Q3SA.dialog 507,1111
}

alias -l Q3SA.check_for_update {
    echo -s Checking for updates...
    if ($1 == auto) {
        set %Q3SA.autocheck $true
    }
    else {
        set %Q3SA.autocheck $false
    }
    sockopen Q3SA_version q3sa.gamedaemon.com 80
}

; copy or report the current server information
alias -l Q3SA.copy {
    ; make sure the dialog is up
    if ($dialog(Q3SA.dialog) != $null) {
        ; determine the copy format being used
        var %format = $readini(%Q3SA.ini,n,main,copy_format)
        ; create the properly formatted string based on the copy format
        if (%format == 2) {
            ; Arena Scout format
            var %output $Q3SA.expand($chr(91) @{server_ip} $chr(93) ping:@{ping}ms map:@{mapname} players:@{playercount}/@{sv_maxclients}/@{sv_privateclients} $chr(91) @{sv_hostname} $chr(93))
        }
        elseif (%format == 3) {
            ; q3p format
            var %output $Q3SA.expand($chr(160) @{ping} $chr(160) @{server_ip} $chr(160) "@{sv_hostname}" $chr(160) @{mapname} $chr(160) @{playercount}/@{sv_maxclients} $chr(160) @{gametype} $chr(160) @{gamename})
        }
        elseif (%format == 4) {
            ; zSpy format
            var %output $Q3SA.expand($chr(40) $+ 05@{ping}ms $+ $chr(41) $chr(40) $+ 05@{sv_hostname} $+ $chr(41) 05@{server_ip} $chr(40) $+ 05@{mapname} @{playercount}/@{sv_maxclients} $+ $chr(41) $chr(40) $+ 05@{score_time} $+ $chr(41))
        }
        elseif (%format == 5) {
            ; custom format -- read in custom format from ini
            var %output $Q3SA.expand($readini(%Q3SA.ini,n,main,custom_copy))
        }
        else {
            ; Q3SA standard format
            var %output $Q3SA.expand(@{server_ip})
        }

    }

    ; if it's a report, send it to the active window, otherwise, copy it to the clipboard
    if ($1 == report) { msg $active %output }
    else { clipboard %output $+ $crlf }
}

alias -l Q3SA.download_current_version {
    sockopen Q3SA_download q3sa.gamedaemon.com 80
}

; launch quake 3
alias -l Q3SA.execute {
    ; $1 = ip address
    ; $2 = player name
    ; $3 = config file to execute
    ; $4 = password
    ; $5 = other command line options

    var %command_line

    ; set the command line options based on the parameters set on call to execute
    ; set ip address to connect to
    if ($1 != $null) { set %command_line %command_line +connect $1 }
    ; set quake 3 name
    if ($2 != $null) { set %command_line %command_line +name $2 }
    ; execute a specific config file
    if ($3 != $null) { set %command_line %command_line +exec $3 }
    ; set a password
    if ($4 != $null) { set %command_line %command_line +password $4 }
    ; include additional command line parameters
    if ($5 != $null) { set %command_line %command_line $5 }

    ; launch the file
    if ($readini(%Q3SA.ini,n,main,debug) >= 1) {
        echo -s $readini(%Q3SA.ini,n,main,q3_executable) %command_line
    }
    else {
        run -p $readini(%Q3SA.ini,n,main,q3_executable) %command_line
    }

    return $null
}

; expands @{variables} into their values
alias -l Q3SA.expand {
    var %original = $1-
    var %expanded = %original
    var %lcv = 1, %found_var = $false, %variable, %var_count, %cur_char, %value

    ; count how many variables there are to replace
    set %var_count $count(%original,$chr(64) $+ $chr(123))

    ; loop through and process each one
    while (%var_count > 0) {
        ; get the character where the @{ starts
        set %lcv $pos(%original,$chr(64) $+ $chr(123),%var_count)
        ; then move it forward 2 spaces to get to the actual variable name
        inc %lcv 2
        set %found_var $true
        set %variable $chr(64) $+ $chr(123)

        ; while still inside the variable & we haven't run out of string
        while (%found_var && (%lcv <= $len(%original))) {
            ; get the current character
            set %cur_char $mid(%original,%lcv,1)

            ; if it's a closing brace, we've made it to the end of the variable
            if (%cur_char == $chr(125)) {
                 ; record the last character and set found_var to false to
                 ; indicate we're done with this one
                 set %variable $+(%variable,%cur_char)
                 set %found_var $false
            }
            ; otherwise, if it's a legal variable name character
            elseif ((%cur_char isalnum) || (%cur_char == _)) {
                ; record the character
                set %variable $+(%variable,%cur_char)
            }
            ; it's not legal, we're done.  more robust error checking could be done
            ; here but this bail out method is safe enough for now
            else { set %found_var $false }
            inc %lcv
        }
        ; set %value to be the value of the svar that we have stored (if we have it at all)
        set %value %Q3SA.svar. [ $+ [ $remove(%variable,$chr(64),$chr(123),$chr(125)) ] ]
        ; then replace all the oc
        set %expanded $replace(%expanded,%variable,%value)
        dec %var_count
    }
    ; return the expanded value
    return %expanded
}

alias Q3SA.format_filesize {
    ; $1 = filesize in bytes
    var %temp = $bytes($1,3).suf
    return $left(%temp,-2) $right(%temp,2)
}

; return the ip portion of an address without the port
alias -l Q3SA.get_ip_only {
    if ($numtok($1,58) == 2) { return $gettok($1,1,58) }
    else { return $1 }
}

; return the port portion of an address without the ip
alias -l Q3SA.get_port_only {
    if ($numtok($1,58) == 2) { return $gettok($1,2,58) }
    else { return 27960 }
}

; make a backslash seperated list of all the arguments
alias -l infostring {
    if ( $1- == $null ) return $chr(92)
    var %list
    var %wpm = 1
    while ( $ [ $+ [ %wpm ] ] != $null ) {
        set %list $instok(%list, $ [ $+ [ %wpm ] ] ,0,92)
        inc %wpm
    }
    return %list
}

alias -l Q3SA.in_favorite_group {
    ; $1 = server ip
    ; $2 = group to check
    var %data = $readini(%Q3SA.ini,n,favorites,$1)

    if (%data != $null) {
        return $istok($gettok(%data,3,92),$2,96)
    }
    else {
        return $false
    }
}

; verify that .ini file is useable.  if not, upgrade it or use the default
alias -l Q3SA.ini_check {
    set %Q3SA.ini $shortfn($scriptdir) $+ q3sa.ini
    var %Q3SA.default.ini $shortfn($scriptdir) $+ q3sa.default.ini
    var %count = 1, %candidate, %version, %loop

    if ($isfile(%Q3SA.ini)) {
        if ($ini(%Q3SA.ini,ini,version) > 0) { set %version $readini(%Q3SA.ini,n,ini,version) }
        else { set %version 0 }

        if (%version != $Q3SA.ini_version) {
            if ($Q3SA.ini_upgradable(%version)) {
                set %loop 0
                while ($isfile($shortfn($scriptdir) $+ q3sa.backup $+ %loop $+ .ini)) { inc %loop }
                var %backup = $shortfn($scriptdir) $+ q3sa.backup $+ %loop $+ .ini
                echo -s Your old q3sa.ini file will be upgraded.  The original has been saved as %backup $+ .
                copy %Q3SA.ini %backup
                Q3SA.ini_upgrade %Q3SA.ini %version $Q3SA.ini_version
            }
            else {
                if ($isfile(%Q3SA.default.ini)) {
                    %loop 0
                    while ($isfile($shortfn($scriptdir) $+ q3sa.backup $+ %loop $+ .ini)) { inc %loop }
                    var %backup = $shortfn($scriptdir) $+ q3sa.backup $+ %loop $+ .ini
                    echo -s Your old q3sa.ini file is unusable with this version.  It has been saved as %backup and q3sa.default.ini will be used as your q3sa.ini.
                    copy %Q3SA.ini %backup
                    copy -o %Q3SA.default.ini %Q3SA.ini
                }
                else {
                    echo -s Error: Your old q3sa.ini file is unusable with this version.  Normally, this is not a problem, but I cannot find q3sa.default.ini to use instead.  Please re-install.
                    halt
                }
            }
        }
        else { return }
    }
    elseif ($isfile(%Q3SA.default.ini)) {
        copy %Q3SA.default.ini %Q3SA.ini
    }
    else {
        echo -s Error: Cannot find q3sa.ini or q3sa.default.ini.  Please re-install.
        halt
    }
}

; comparison routine for filter command
alias Q3SA.ini_compare {
    var %v1 = $lower($gettok($nopath($1),2,46))
    var %v2 = $lower($gettok($nopath($2),2,46))
    if ((%v1 isnum) && (%v2 isnum)) { return $iif(%v1 < %v2, 1, -1) }
    elseif ((%v1 isnum) && (%v2 == default)) { return -1 }
    elseif ((%v2 isnum) && (%v1 == default)) { return 1 }
    else { return 0 }
}


alias -l Q3SA.ini_upgradable {
    ; $1 = version that needs to be upgraded
    var %old_ver = $1
    var %new_ver = $Q3SA.ini_version
    var %ini = $shortfn($scriptdir) $+ ini.ini

    if ($isfile(%ini)) {
        return iif (%old_ver >= $readini(%ini,n,upgradable,%new_ver),$true,$false)
    }
    else {
        Error: Cannot find the file "ini.ini".  Forced into assuming that all ini files are non-upgradable.
        return $false
    }
}

alias -l Q3SA.ini_upgrade {
    ; $1 = file to upgrade
    ; $2 = old ver
    ; $3 = new ver

    if (!$isfile($1)) {
        echo -s Error: Cannot upgrade file $1: file not found
        halt
    }

    var %topic_loop = 1, %item_loop
    var %topics = $ini($1,0), %items, %cur_item, %cur_topic
    var -s %old_ver = $2, %new_ver = $3, %ver_loop = $calc(%old_ver + 1)
    var %source = $1, %target = $shortfn($scriptdir) $+ q3sa.initemp
    var %ini = $shortfn($scriptdir) $+ ini.ini
    var %new_loop, %new_items, %key, %value, %section

    while (%ver_loop <= %new_ver) {
        .remove %target

        while (%topic_loop <= %topics) {
            set %items $ini(%source,%topic_loop,0)
            set %cur_topic $ini(%source,%topic_loop)
            set %item_loop 1
            while (%item_loop <= %items) {
                set %cur_item $ini(%source,%topic_loop,%item_loop)
                set %status $readini(%ini,n,%ver_loop $+ _old,%cur_item)

                if (%status == $null) {
                    writeini -n %target %cur_topic %cur_item $readini(%source,n,%cur_topic,%cur_item)
                }
                elseif ($left(%status,7) == changed) {
                    writeini -n %target %cur_topic %cur_item $gettok(%status,2,92)
                }
                inc %item_loop
            }
            inc %topic_loop
        }

        set %new_items $ini(%ini,%ver_loop $+ _in,0)
        set %item_loop 1
        while (%item_loop <= %new_items) {
            set %key $ini(%ini,%ver_loop $+ _new,%item_loop)
            set %value $readini(%ini,n,%ver_loop $+ _new,%key)
            set %section $gettok(%value,1,92)
            set %value $gettok(%value,2,92)
            writeini -n %target %section %key %value
            inc %item_loop
        }

        flushini %target

        var %req_items = $ini(%ini,%ver_loop $+ _required,0)
        set %item_loop 1
        while (%item_loop <= %req_items) {
            set %key $ini(%ini,%ver_loop $+ _new,%item_loop)
            set %value $readini(%ini,n,%ver_loop $+ _new,%key)
            set %section $gettok(%value,1,92)
            set %value $gettok(%value,2,92)

            if ($ini(%target,%section,%key) == 0) {
                writeini -n %target %section %key %value
            }

            inc %item_loop
        }

        flushini %target
        flushini %source
        if ($isfile(%target)) {
            copy -o %target %source
            remove %target
        }
        else {
            echo -s Error upgrading your settings.  Your backup is still safe.
            halt
        }
        inc %ver_loop
     }
     writeini -n %source ini version %new_ver
     flushini %source
}

alias -l Q3SA.ini_version {
    return 3
}

alias -l Q3SA.ip_pad {
    var %ip, %port

    if ($numtok($1,58) == 2) {
        var %ip = $gettok($1,1,58)
        var %port = $gettok($1,2,58)
    }
    else {
        var %ip = $1
        var %port = 27960
    }

    var %a = $base($gettok(%ip,1,46),10,10,3)
    var %b = $base($gettok(%ip,2,46),10,10,3)
    var %c = $base($gettok(%ip,3,46),10,10,3)
    var %d = $base($gettok(%ip,4,46),10,10,3)
    set %port $base(%port,10,10,5)

    return %a $+ . $+ %b $+ . $+ %c $+ . $+ %d $+ : $+ %port
}

alias -l Q3SA.ip_unpad {
    var %ip, %port

    if ($numtok($1,58) == 2) {
        var %ip = $gettok($1,1,58)
        var %port = $gettok($1,2,58)
    }
    else {
        var %ip = $1
        var %port = 27960
    }

    var %a = $abs($gettok(%ip,1,46))
    var %b = $abs($gettok(%ip,2,46))
    var %c = $abs($gettok(%ip,3,46))
    var %d = $abs($gettok(%ip,4,46))
    set %port $abs(%port)

    return %a $+ . $+ %b $+ . $+ %c $+ . $+ %d $+ : $+ %port
}

alias -l Q3SA.is_favorite {
    if ($ini(%Q3SA.ini,favorites,$1) != 0) { return $true }
    else { return $false }
}

alias -l Q3SA.is_valid_address {
    if ($1 == $null) { return $false }
    if ($pos($1,.,0) > 3) { return $false }
    if ($pos($1,:,0) > 1) { return $false }
    if ($pos($1,:,1) == $len($1)) { return $false }

    if ($numtok($1,58) == 2) {
        var %ip = $gettok($1,1,58)
        var %port = $gettok($1,2,58)
    }
    else {
        var %ip = $1
        var %port = 27960
    }

    if ($numtok(%ip,46) == 4) {
        var %a = $gettok(%ip,1,46)
        var %b = $gettok(%ip,2,46)
        var %c = $gettok(%ip,3,46)
        var %d = $gettok(%ip,4,46)
        if ((%a isnum 0-255) && (%b isnum 0-255) && (%c isnum 0-255) && (%d isnum 0-255) && (%port isnum 0-65535)) { return $true }
    }
    return $false
}

alias -l Q3SA.load_favorites {
    ; $1 = column to sort on
    ; $2 = asc/desc
    ; $3 = group name
    var %fav_count = $ini(%Q3SA.ini, favorites, 0)
    var %lcv = 1
    var %ip, %joins, %name, %data
    var %fn1 = q3sa_sort1.txt, %fn2 = q3sa_sort2.txt
    var %column, %order, %groups

    set %column $iif($1 == $null, 1, $1)
    set %order $iif($2 == $null, $hget(Q3SA.sort_data,fav_sort_order_ $+ %column), $2)

    if ($3 != $null) {
        writeini -n %Q3SA.ini main active_group $3
        set %Q3SA.current_group $3
    }
    elseif (%Q3SA.current_group == $null) {
        writeini -n %Q3SA.ini main active_group <All>
        set %Q3SA.current_group <All>
    }

    write -c %fn1
    while (%lcv <= %fav_count) {
        set %ip $ini(%Q3SA.ini,favorites,%lcv)
        set %data $readini(%Q3SA.ini,n,favorites,%ip)
        set %joins $base($gettok(%data,1,92),10,10,5)
        set %name $gettok(%data,2,92)
        set %groups $gettok(%data,3,92)

        if (%Q3SA.current_group == <All>) {
            write %fn1 $tab(%joins,%name,$Q3SA.ip_pad(%ip))
        }
        else {
            if ((%Q3SA.current_group == <Unassigned>) && (%groups == $null)) {
                write %fn1 $tab(%joins,%name,$Q3SA.ip_pad(%ip))
            }
            elseif ($istok(%groups,%Q3SA.current_group,96)) {
                write %fn1 $tab(%joins,%name,$Q3SA.ip_pad(%ip))
            }
        }
        inc %lcv
    }

    if ((%column isnum 1-3) && ($istok(asc desc,%order,32))) {
        if (%order == asc) { filter -ctx %column 9 %fn1 %fn2 $crlf }
        else { filter -ctex %column 9 %fn1 %fn2 $crlf }

        hadd -m Q3SA.sort_data fav_sort_column %column
        hadd -m Q3SA.sort_data fav_sort_order_ $+ %column %order

        set %lcv 1
        did -r Q3SA.dialog 202
        while (%lcv <= $filtered) {
            set %data $read(%fn2,nt,%lcv)
            set %joins $abs($gettok(%data,1,9))
            set %name $gettok(%data,2,9)
            set %ip $Q3SA.ip_unpad($gettok(%data,3,9))
            ;echo -s did -a Q3SA.dialog 202 $tab(+ 0 0 0 %joins,+ 0 0 0 %name,+ 0 0 0 %ip)
            did -a Q3SA.dialog 202 $tab(+ 0 0 0 %joins,+ 0 0 0 %name,+ 0 0 0 %ip)
            inc %lcv
        }
    }

    .remove %fn1
    .remove %fn2
}

alias -l Q3SA.load_groups {
    var %group_count = $ini(%Q3SA.ini, groups, 0)
    var %active_group = $readini(%Q3SA.ini,n,main,active_group)
    var %lcv = 1

    did -ra Q3SA.dialog 601 <All>
    did -a Q3SA.dialog 601 <Unassigned>

    while (%lcv <= %group_count) {
        did -a Q3SA.dialog 601 $ini(%Q3SA.ini,groups,%lcv)
        inc %lcv
    }

    var %line = $didwm(Q3SA.dialog,601,%active_group)
    if (%line > 0) {
        did -c Q3SA.dialog 601 %line
    }
    else {
        set %line $didwm(Q3SA.dialog,601,<All>)
        did -c Q3SA.dialog 601 %line
        writeini -n %Q3SA.ini main active_group <All>
    }
}

alias -l Q3SA.load_options {
    if ($dialog(Q3SA.options_dialog) == $null) { halt }

    if ($readini(%Q3SA.ini,n,main,set_irc_name) == 1) {
        did -c Q3SA.options_dialog 101
        did -n Q3SA.options_dialog 102
    }
    if ($readini(%Q3SA.ini,n,main,announce_connection) == 1) {
        did -c Q3SA.options_dialog 103
        did -n Q3SA.options_dialog 104
    }
    if ($readini(%Q3SA.ini,n,main,set_away) == 1) {
        did -c Q3SA.options_dialog 105
        did -n Q3SA.options_dialog 106
    }
    if ($readini(%Q3SA.ini,n,main,version_reply) == 1) {
        did -c Q3SA.options_dialog 107
        did -n Q3SA.options_dialog 107
    }

    if ($readini(%Q3SA.ini,n,main,warn_join_pw) == 1) { did -c Q3SA.options_dialog 201 }

    if ($readini(%Q3SA.ini,n,main,warn_priority_pw) == 1) { did -c Q3SA.options_dialog 202 }

    if ($readini(%Q3SA.ini,n,main,execute_config) == 1) {
        did -c Q3SA.options_dialog 304
        did -n Q3SA.options_dialog 305
    }

    if ($readini(%Q3SA.ini,n,main,set_q3_name) == 1) {
        did -c Q3SA.options_dialog 307
        did -n Q3SA.options_dialog 308
    }

    if ($readini(%Q3SA.ini,n,main,set_other_command_line_options) == 1) {
        did -c Q3SA.options_dialog 309
        did -n Q3SA.options_dialog 310
    }

    if ($readini(%Q3SA.ini,n,main,window_parent) == Desktop) { did -c Q3SA.options_dialog 204 }
    elseif ($readini(%Q3SA.ini,n,main,window_parent) == mIRC) { did -c Q3SA.options_dialog 205 }

    var %cf = $readini(%Q3SA.ini,n,main,copy_format)
    if (%cf == 1) { did -c Q3SA.options_dialog 406 }
    elseif (%cf == 2) { did -c Q3SA.options_dialog 401 }
    elseif (%cf == 3) { did -c Q3SA.options_dialog 402 }
    elseif (%cf == 4) { did -c Q3SA.options_dialog 403 }
    elseif (%cf == 5) {
        did -c Q3SA.options_dialog 404
        did -n Q3SA.options_dialog 405
    }
    else {
        writeini %Q3SA.ini main copy_format 1
        did -c Q3SA.options_dialog 406
    }

    did -ra Q3SA.options_dialog 102 $readini(%Q3SA.ini,n,main,irc_name)
    did -ra Q3SA.options_dialog 104 $readini(%Q3SA.ini,n,main,announce_message)
    did -ra Q3SA.options_dialog 106 $readini(%Q3SA.ini,n,main,away_message)
    did -ra Q3SA.options_dialog 208 $readini(%Q3SA.ini,n,main,monitor_interval)
    did -ra Q3SA.options_dialog 210 $readini(%Q3SA.ini,n,main,timeout_value)
    did -ra Q3SA.options_dialog 302 $readini(%Q3SA.ini,n,main,q3_executable)
    did -ra Q3SA.options_dialog 305 $readini(%Q3SA.ini,n,main,config_file)
    did -ra Q3SA.options_dialog 308 $readini(%Q3SA.ini,n,main,q3_name)
    did -ra Q3SA.options_dialog 310 $readini(%Q3SA.ini,n,main,command_line)
    did -ra Q3SA.options_dialog 405 $readini(%Q3SA.ini,n,main,custom_copy)
}

alias -l Q3SA.load_passwords {
    var %ip $did(Q3SA.dialog,300)
    var %player_info $remove($did(Q3SA.dialog,309), $chr(32))
    var %players $gettok(%player_info,1,47)
    var %private $gettok(%player_info,2,47)
    var %max $gettok(%player_info,3,47)

    did -r Q3SA.dialog 600
    didtok Q3SA.dialog 600 9 $readini(%Q3SA.ini,passwords,%ip)
    did -e Q3SA.dialog 600
}

alias -l Q3SA.make_full_address {
    ; must be valid address to begin with

    if ($numtok($1,58) == 2) {
        var %ip $gettok($1,1,58)
        var %port $gettok($1,2,58)
    }
    else {
        var %ip $1
        var %port 27960
    }
    return %ip $+ : $+ %port
}

alias -l Q3SA.monitor_tick {
    if ($dialog(Q3SA.dialog) == $null) {
        .timerQ3SAMonitor off
        halt
    }

    if ($Q3SA.is_valid_address($did(Q3SA.dialog, 300))) {
        Q3SA.update_server $did(Q3SA.dialog, 300)
    }
}

alias -l Q3SA.q3connect {
    var %password = $did(Q3SA.dialog,600,0)
    var %players = $gettok(%player_info,1,47)
    var %private = $gettok(%player_info,2,47)
    var %name = $null, %config = $null, %command_line = $null
    var %max = $gettok(%player_info,3,47)
    var %join = $yes, %button_state = 0

    if ($did(Q3SA.dialog,600,0) != $null) {
        var %pw = $readini(%Q3SA.ini,n,passwords,$did(Q3SA.dialog,300))
        if (!$istok(%pw,$did(Q3SA.dialog,600,0),92)) {
            writeini %Q3SA.ini passwords $did(Q3SA.dialog,300) $instok(%pw,$did(Q3SA.dialog,600,0),0,92)
        }
    }

    if (($did(Q3SA.dialog,312) == Yes) && (%password == $null)) {
        set %join $input(The server requires a password to connect and you have not supplied one.  Would you like to connect without it?, 304, Join Password Required)
    }
    elseif (($calc(%max - %private) <= %players) && (%password == $null)) {
        set %join $input(The server is full right now and will require a priority password to connect.  You have not supplied one.  Would you like to connect without it?, 304, Priority Password Required)
    }

    if (%join == $yes) {
        if ($readini(%Q3SA.ini,n,main,announce_connection) == 1) {
            ame $Q3SA.expand($readini(%Q3SA.ini,n,main,announce_message))
        }
        if ($readini(%Q3SA.ini,n,main,set_irc_name) == 1) {
            set %Q3SA.original_nick $me
            nick $readini(%Q3SA.ini,n,main,irc_name)
            set %button_state 1
        }
        if ($readini(%Q3SA.ini,n,main,set_away) == 1) {
            away $Q3SA.expand($readini(%Q3SA.ini,n,main,away_message))
            set %button_state 1
        }

        if ($readini(%Q3SA.ini,n,main,set_q3_name) == 1) { set %name $readini(%Q3SA.ini,n,main,q3_name) }
        if ($readini(%Q3SA.ini,n,main,execute_config) == 1) { set %config $Q3SA.expand($readini(%Q3SA.ini,n,main,config_file)) }
        if ($readini(%Q3SA.ini,n,main,set_other_command_line_options) == 1) { set %command_line $Q3SA.expand($readini(%Q3SA.ini,n,main,command_line)) }

        if ($Q3SA.is_favorite($did(Q3SA.dialog,300))) {
            Q3SA.record_join $did(Q3SA.dialog,300)
        }

        if ((%button_state == 1) && ($did(Q3SA.dialog,507).state == 0)) { did -c Q3SA.dialog 507 }
        elseif ((%button_state == 0) && ($did(Q3SA.dialog,507).state == 1)) { did -u Q3SA.dialog 507 }

        if ((%button_state == 1) && ($did(Q3SA.dialog,1111).state == 0)) { did -c Q3SA.dialog 1111 }
        elseif ((%button_state == 0) && ($did(Q3SA.dialog,1111).state == 1)) { did -u Q3SA.dialog 1111 }

        %result = $Q3SA.execute($did(Q3SA.dialog,300), %name, %config, %password, %command_line)
    }
    else {
        did -u Q3SA.dialog 507,1111
    }
}

alias -l Q3SA.record_join {
    ; $1 = ip address
    var %data = $readini(%Q3SA.ini,n,favorites,$1)
    var %joins = $calc($gettok(%data,1,92) + 1)
    set %data $puttok(%data,%joins,1,92)
    writeini %Q3SA.ini favorites $1 %data

    Q3SA.refresh_favorites
    Q3SA.select_favorite_line $1
}

alias -l Q3SA.refresh_favorites {
    var %column = $hget(Q3SA.sort_data,fav_sort_column)
    var %order = $hget(Q3SA.sort_data,fav_sort_order_ $+ %column)
    Q3SA.load_favorites %column %order
}

alias -l Q3SA.refresh_playerlist {
    var %column = $hget(Q3SA.sort_data,player_sort_column)
    var %order = $hget(Q3SA.sort_data,player_sort_order_ $+ %column)
    Q3SA.sort_playerlist %column %order
}

alias -l Q3SA.remove_favorite {
    if (($1 != $null) && ($Q3SA.is_valid_address($1))) {
        var %address = $Q3SA.make_full_address($1)
        if ($ini(%Q3SA.ini,favorites,%address) != 0) {
            remini %Q3SA.ini favorites %address
            did -b Q3SA.dialog 510,1121,1122
            did -e Q3SA.dialog 509
            did -u Q3SA.dialog 580
            Q3SA.load_favorites %column $hget(Q3SA.sort_data,fav_sort_order_ $+ %column)
        }
    }
}

alias -l Q3SA.save_groups {
    var %old_groups, %server_groups, %new_groups = $didtok(Q3SA.options_dialog,501,96)
    var %lcv = 1, %lcv2 = 1
    var %count = $ini(%Q3SA.ini,groups,0), %count2

    while (%lcv <= %count) {
        set %old_groups $addtok(%old_groups, $ini(%Q3SA.ini,groups,%lcv), 96)
        inc %lcv
    }

    set %lcv 1
    set %count $numtok(%new_groups,96)
    while (%lcv <= %count) {
        if (!$istok(%old_groups,$gettok(%new_groups,%lcv,96),96)) {
            writeini -n %Q3SA.ini groups $gettok(%new_groups,%lcv,96) 0
        }
        inc %lcv
    }

    set %lcv 1
    set %count $numtok(%old_groups,96)
    while (%lcv <= %count) {
        if (!$istok(%new_groups,$gettok(%old_groups,%lcv,96),96)) {
            remini %Q3SA.ini groups $gettok(%old_groups,%lcv,96)
        }
        inc %lcv
    }

    set %lcv 1
    set %count $ini(%Q3SA.ini,favorites,0)
    while (%lcv <= %count) {
        var %ip = $ini(%Q3SA.ini,favorites,%lcv)
        var %data = $readini(%Q3SA.ini,n,favorites,%ip)
        var %joins = $gettok(%data,1,92)
        var %name = $gettok(%data,2,92)
        var %groups = $gettok(%data,3,92)

        set %lcv2 1
        set %count2 $numtok(%groups,96)
        set %server_groups $null

        while (%lcv2 <= %count2) {
            if ($istok(%new_groups,$gettok(%groups,%lcv2,96),96)) {
                set %server_groups $addtok(%server_groups,$gettok(%groups,%lcv2,96),96)
            }
            inc %lcv2
        }

        writeini -n %Q3SA.ini favorites %ip $infostring(%joins,%name,%server_groups)
        inc %lcv
    }
}

alias -l Q3SA.save_options {
    writeini %Q3SA.ini main set_irc_name $did(Q3SA.options_dialog,101).state
    writeini %Q3SA.ini main announce_connection $did(Q3SA.options_dialog,103).state
    writeini %Q3SA.ini main set_away $did(Q3SA.options_dialog,105).state
    writeini %Q3SA.ini main version_reply $did(Q3SA.options_dialog,107).state
    writeini %Q3SA.ini main warn_join_pw $did(Q3SA.options_dialog,201).state
    writeini %Q3SA.ini main warn_priority_pw $did(Q3SA.options_dialog,202).state
    writeini %Q3SA.ini main execute_config $did(Q3SA.options_dialog,304).state
    writeini %Q3SA.ini main set_q3_name $did(Q3SA.options_dialog,307).state
    writeini %Q3SA.ini main set_other_command_line_options $did(Q3SA.options_dialog,309).state

    if ($did(Q3SA.options_dialog,102) != $null) { writeini %Q3SA.ini main irc_name $did(Q3SA.options_dialog,102) }
    else { remini %Q3SA.ini main irc_name }
    if ($did(Q3SA.options_dialog,104) != $null) { writeini %Q3SA.ini main announce_message $did(Q3SA.options_dialog,104) }
    else { remini %Q3SA.ini main announce_message }
    if ($did(Q3SA.options_dialog,106) != $null) { writeini %Q3SA.ini main away_message $did(Q3SA.options_dialog,106) }
    else { remini %Q3SA.ini main away_nick_format }
    if ($did(Q3SA.options_dialog,208) != $null) { writeini %Q3SA.ini main monitor_interval $did(Q3SA.options_dialog,208) }
    else { remini %Q3SA.ini main monitor_interval }
    if ($did(Q3SA.options_dialog,210) != $null) { writeini %Q3SA.ini main timeout_value $did(Q3SA.options_dialog,210) }
    else { remini %Q3SA.ini main timeout_value }
    if ($did(Q3SA.options_dialog,302) != $null) { writeini %Q3SA.ini main q3_executable $did(Q3SA.options_dialog,302) }
    else { remini %Q3SA.ini main q3_executable }
    if ($did(Q3SA.options_dialog,305) != $null) { writeini %Q3SA.ini main config_file $did(Q3SA.options_dialog,305) }
    else { remini %Q3SA.ini main config_file }
    if ($did(Q3SA.options_dialog,308) != $null) { writeini %Q3SA.ini main q3_name $did(Q3SA.options_dialog,308) }
    else { remini %Q3SA.ini main q3_name }
    if ($did(Q3SA.options_dialog,310) != $null) { writeini %Q3SA.ini main command_line $did(Q3SA.options_dialog,310) }
    else { remini %Q3SA.ini main command_line }
    if ($did(Q3SA.options_dialog,405) != $null) { writeini %Q3SA.ini main custom_copy $did(Q3SA.options_dialog,405) }
    else { remini %Q3SA.ini main custom_copy }

    if ($did(Q3SA.options_dialog,204).state == 1) { writeini %Q3SA.ini main window_parent Desktop }
    elseif ($did(Q3SA.options_dialog,205).state == 1) { writeini %Q3SA.ini main window_parent mIRC }

    if ($did(Q3SA.options_dialog,406).state == 1) { writeini %Q3SA.ini main copy_format 1 }
    elseif ($did(Q3SA.options_dialog,401).state == 1) { writeini %Q3SA.ini main copy_format 2 }
    elseif ($did(Q3SA.options_dialog,402).state == 1) { writeini %Q3SA.ini main copy_format 3 }
    elseif ($did(Q3SA.options_dialog,403).state == 1) { writeini %Q3SA.ini main copy_format 4 }
    elseif ($did(Q3SA.options_dialog,404).state == 1) { writeini %Q3SA.ini main copy_format 5 }
    else { writeini %Q3SA.ini main copy_format 1 }

    set %Q3SA.timeout_value $iif($did(Q3SA.options_dialog,210) == $null, 999, $did(Q3SA.options_dialog,210))

    Q3SA.save_groups
    Q3SA.load_groups
    Q3SA.load_favorites

    did -b Q3SA.options_dialog 4
}

alias -l Q3SA.select_favorite_line {
    ; $1 = ip address of line in favorites to select
    var %lcv = 2
    var %ip, %data
    var %max = $calc($did(Q3SA.dialog,202).lines + 1)

    while (%lcv <= %max) {
        if ($1 == $gettok($did(Q3SA.dialog,202,%lcv),-1,32)) {
            did -c Q3SA.dialog 202 %lcv
            set %lcv %max
        }
        inc %lcv
    }
}

alias -l Q3SA.set_invalid {
    set %Q3SA.valid $false
    set %Q3SA.invalid $true
    did -bv Q3SA.dialog 502,503,507
    did -b Q3SA.dialog 509,510,1111,1113,1121,1122,580
}

alias -l Q3SA.set_valid {
    set %Q3SA.valid $true
    set %Q3SA.invalid $false
    did -e Q3SA.dialog 502,503,507,1111,1113
    if ($Q3SA.is_favorite($Q3SA.make_full_address($did(Q3SA.dialog,300)))) {
        did -b Q3SA.dialog 509
        did -e Q3SA.dialog 510,580
        did -c Q3SA.dialog 580
        if ((%Q3SA.current_group == <All>) || (%Q3SA.current_group == <Unassigned>)) {
            did -b Q3SA.dialog 1121,1122
        }
        elseif ($Q3SA.in_favorite_group($Q3SA.make_full_address($did(Q3SA.dialog,300)),%Q3SA.current_group)) {
            did -e Q3SA.dialog 1122
            did -b Q3SA.dialog 1121
        }
        else {
            did -e Q3SA.dialog 1121
            did -b Q3SA.dialog 1122
        }
    }
    else {
        did -b Q3SA.dialog 510,1121,1122
        did -e Q3SA.dialog 509,580
        did -u Q3SA.dialog 580
    }
}

alias -l Q3SA.sort_playerlist {
    ; $1 = column to sort on
    ; $2 = asc/desc

    var %lcv = 1
    var %frags, %ping, %name, %data
    var %fn, %list
    var %column, %order
    var %player_count

    set %column $iif($1 == $null, 1, $1)
    set %order $iif($2 == $null, $hget(Q3SA.sort_data,player_sort_order_ $+ %column), $2)

    if (%Q3SA.team_mode && (%Q3SA.player_view == Blue)) {
        set %player_count %Q3SA.svar.blue_playercount
        set %fn $shortfn($scriptdir) $+ players_blue.temp
        set %list 203
    }
    elseif (%Q3SA.team_mode && (%Q3SA.player_view == Red)) {
        set %player_count %Q3SA.svar.red_playercount
        set %fn $shortfn($scriptdir) $+ players_red.temp
        set %list 204
    }
    elseif (%Q3SA.team_mode && (%Q3SA.player_view == Spec)) {
        set %player_count %Q3SA.svar.spec_playercount
        set %fn $shortfn($scriptdir) $+ players_spec.temp
        set %list 205
    }
    else {
        set %player_count %Q3SA.svar.playercount
        set %fn $shortfn($scriptdir) $+ players_all.temp
        set %list 201
    }

    if (%player_count > 0) {
        if ((%column isnum 1-3) && ($istok(asc desc,%order,32))) {
            if (%order == asc) { filter -ct %column 9 %fn %fn * }
            else { filter -cte %column 9 %fn %fn * }

            hadd -m Q3SA.sort_data player_sort_column %column
            hadd -m Q3SA.sort_data player_sort_order_ $+ %column %order

            set %lcv 1
            did -r Q3SA.dialog %list
            while (%lcv <= $filtered) {
                set %data $read(%fn,nt,%lcv)
                set %frags $abs($gettok(%data,1,9))
                set %ping $abs($gettok(%data,2,9))
                set %name $gettok(%data,3,9)
                did -a Q3SA.dialog %list $tab(+ 0 0 0 %frags,+ 0 0 0 %ping,+ 0 0 0 %name)
                inc %lcv
            }
        }
    }
}

alias Q3SA.start {
    if ($dialog(Q3SA.dialog) != $null) { halt }

    Q3SA.ini_check

    set %Q3SA.timeout_value $readini(%Q3SA.ini,n,main,timeout_value)
    if (%Q3SA.timeout_value == $null) { set %Q3SA.timeout_value 999 }
    set %Q3SA.server_info $null
    set %Q3SA.valid $false
    set %Q3SA.invalid $true
    set %Q3SA.team_mode $false
    set %Q3SA.debug $readini(%Q3SA.ini,n,main,debug)
    if (%Q3SA.debug == $null) { set %Q3SA.debug 0 }

    set %Q3SA.players_fn $shortfn($scriptdir) $+ players_all.temp
    set %Q3SA.blue_fn $shortfn($scriptdir) $+ players_blue.temp
    set %Q3SA.red_fn $shortfn($scriptdir) $+ players_red.temp
    set %Q3SA.spec_fn $shortfn($scriptdir) $+ players_spec.temp

    if ($readini(%Q3SA.ini,main,auto_check) == 1) {
        Q3SA.check_for_update auto
    }

    if ($readini(%Q3SA.ini,main,window_parent) == Desktop) { .dialog -md Q3SA.dialog Q3SA.dialog }
    else { .dialog -m Q3SA.dialog Q3SA.dialog }
}

alias -l Q3SA.strip_colors {
    if ($1 == $null) { return }
    var %result, %pos, %lcount, %rcount
    set %result $replace($1,^^,$chr(247))

    while ($pos(%result,^,0) > 0) {
        set %pos $pos(%result,^,1)
        set %lcount $calc(%pos - 1)
        set %rcount $calc($len(%result) - %pos - 1)

        if (%lcount < 0) { set %lcount 0 }
        if (%rcount < 0) { set %rcount 0 }

        set %result $left(%result,%lcount) $+ $right(%result,%rcount)
    }

    set %result $replace(%result,$chr(247),^)
    return %result
}

alias -l Q3SA.timeout {
    .sockclose Q3SA
    unset %Q3SA.udp_out
    if ($dialog(Q3SA.dialog) != $null) {
        did -ra Q3SA.dialog 301 SERVER TIMED OUT
        did -b Q3SA.dialog 506
    }
}

alias -l Q3SA.update_server {
    .timerQ3SATimeout off
    if ($1 == $null) { halt }

    if ($Q3SA.is_valid_address($did(Q3SA.dialog,300))) {
        var %address = $Q3SA.make_full_address($did(Q3SA.dialog,300))
        var %ip = $Q3SA.get_ip_only(%address)
        var %port = $Q3SA.get_port_only(%address)
    }
    else {
        echo -s Invalid IP address.
        return
    }

    did -ra Q3SA.dialog 300 %address
    if ($Q3SA.is_valid_address(%address)) {
        Q3SA.set_valid
    }
    else {
        Q3SA.set_invalid
    }
    did -b Q3SA.dialog 504,506,513,600,1117,1118
    did -r Q3SA.dialog 301,303,304,305,306,309,313,314,201
    .sockudp -k Q3SA %ip %port getstatus
    %Q3SA.udp_out = $ticks
    .timerQ3SATimeout -mo 1 %Q3SA.timeout_value Q3SA.timeout
}

alias -l tab {
    if ( $1- == $null ) return $chr(9)
    var %tablist
    var %wpm = 1
    while ( $ [ $+ [ %wpm ] ] != $null ) {
        set %tablist $instok(%tablist, $ [ $+ [ %wpm ] ] ,0,9)
        inc %wpm
    }
    return %tablist
}

alias -l Q3SA.update_available {
    if ($Q3SA.version < %Q3SA.newest_version) {
        if ($input(A newer version of Q3SA is available than the version you are running.  Would you like to download v $+ %Q3SA.newest_version $+ ?, 104, New Version Available!) == $yes) {
            Q3SA.download_current_version
        }
    }
    elseif (($Q3SA.version > %Q3SA.newest_version) && (%Q3SA.autocheck == $false)) {
        if ($input(You seem to be running a beta or modified version of Q3SA.  Updates may or may not be available.  Would you like to download v $+ %Q3SA.newest_version $+ ?, 104, Possible Update Available) == $yes) {
            Q3SA.download_current_version
        }
    }
    elseif (!%Q3SA.autocheck) {
        var %foo = $input(Your version of Q3SA is up to date!, 68, No Update Necessary)
    }
}

alias -l Q3SA.upgrade_Q3SA {
    .load -rs $shortfn($scriptdir) $+ q3sa_vpak.mrc
    if ($isalias(Q3SA.vpak)) {
        if ($isfile(%Q3SA.vpak_filename)) {
            var %filename %Q3SA.vpak_filename
            dialog -c Q3SA.dialog
            Q3SA.vpak -duz $shortfn(%filename) $scriptdir
            var %foo = $input(Done!  Restart Q3SA for the upgrade to take affect., 68, Upgrade Complete!)
            echo -s Reloading Q3SA...
            reload -rs $scriptdir $+ q3sa.mrc
        }
        else {
            echo -s Error: Cannot upgrade, file not found: %Q3SA.vpak_filename
        }
    }
    else {
        echo -s Error: Cannot upgrade because the Q3SA vPak module cannot be loaded.
    }
}

alias Q3SA.version {
    return 0.34
}

alias Q3SA.version_high {
    return 0
}

alias Q3SA.version_low {
    return 34
}

alias Q3SA.version_text {
    return v $+ $Q3SA.version_high $+ . $+ $Q3SA.version_low
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Dialog Event Handlers ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.dialog:INIT:*: {
    dialog -t $dname Q3SA $Q3SA.version_text

    mdx SetMircVersion $version
    mdx MarkDialog $dname
    mdx SetControlMDX $dname 201 listview single report rowselect > $shortfn($scriptdir) $+ views.mdx
    mdx SetControlMDX $dname 202 listview single report rowselect showsel > $shortfn($scriptdir) $+ views.mdx
    mdx SetControlMDX $dname 203 listview single report rowselect > $shortfn($scriptdir) $+ views.mdx
    mdx SetControlMDX $dname 204 listview single report rowselect > $shortfn($scriptdir) $+ views.mdx
    mdx SetControlMDX $dname 205 listview single report rowselect > $shortfn($scriptdir) $+ views.mdx

    mdx SetBorderStyle $dname 300,301,303,304,312,305,307,306,309,310 staticedge

    did -i $dname 201 1 headerdims 40 40 117
    did -i $dname 202 1 headerdims 40 283 130
    did -i $dname 203 1 headerdims 40 40 117
    did -i $dname 204 1 headerdims 40 40 117
    did -i $dname 205 1 headerdims 40 40 117

    did -i $dname 201 1 headertext $tab(+c Frags,+c Ping,+l Name)
    did -i $dname 202 1 headertext $tab(+c Joins,+l Server Name,+l IP Address)
    did -i $dname 203 1 headertext $tab(+c Frags,+c Ping,+l Name)
    did -i $dname 204 1 headertext $tab(+c Frags,+c Ping,+l Name)
    did -i $dname 205 1 headertext $tab(+c Frags,+c Ping,+l Name)

    did -h $dname 500
    .hfree -w Q3SA.sort_data
    .hmake Q3SA.sort_data 10
    hadd -m Q3SA.sort_data fav_sort_column 1
    hadd -m Q3SA.sort_data fav_sort_order_1 desc
    hadd -m Q3SA.sort_data fav_sort_order_2 asc
    hadd -m Q3SA.sort_data fav_sort_order_3 asc

    hadd -m Q3SA.sort_data player_sort_column 1
    hadd -m Q3SA.sort_data player_sort_order_1 desc
    hadd -m Q3SA.sort_data player_sort_order_2 asc
    hadd -m Q3SA.sort_data player_sort_order_3 asc

    did -c $dname 700

    ; disable the menu items that need to be disabled
    did -b $dname 503,506,509,510,1111,1113,1117,1118,1121,1122
    Q3SA.load_groups
    var %column = $hget(Q3SA.sort_data,fav_sort_column)
    var %order = $hget(Q3SA.sort_data,fav_sort_order_ $+ %column)
    Q3SA.load_favorites %column %order $did(Q3SA.dialog,601).seltext
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Dialog SCLICK Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

on 1:DIALOG:Q3SA.dialog:SCLICK:201,203,204,205: {
    did -i $dname $did 1 page event
    var %event = $did($dname,$did,1)

    if ($gettok(%event,1,32) == headerclick) {
        did -i $dname $did 1 page headerevent
        var %event = $did($dname,$did,1)
        var %new_sort_by = $gettok(%event,3,32)

        if ($hget(Q3SA.sort_data,player_sort_column) == %new_sort_by) {
            if ($hget(Q3SA.sort_data,player_sort_order_ $+ %new_sort_by) == asc) {
                Q3SA.sort_playerlist %new_sort_by desc
            }
            else {
                Q3SA.sort_playerlist %new_sort_by asc
            }
        }
        else {
            Q3SA.sort_playerlist %new_sort_by $hget(Q3SA.sort_data,player_sort_order_ $+ %new_sort_by)
        }
    }
}

on 1:DIALOG:Q3SA.dialog:SCLICK:202: {
    did -i $dname $did 1 page event
    var %event = $did($dname,$did,1)

    if ($gettok(%event,1,32) == SCLICK) {
        ;var %ip $gettok($gettok($did($dname, $did, $gettok(%event,3,32)),2,9),5,32)
        var %ip $gettok($did($dname, $did, $gettok(%event,3,32)),-1,32)
        if ($Q3SA.is_valid_address(%ip)) {
            if (%Q3SA.invalid) { Q3SA.set_valid }
            did -ra $dname 300 %ip
            Q3SA.update_server $did($dname, 300)
        }
    }
    elseif ($gettok(%event,1,32) == headerclick) {
        did -i $dname $did 1 page headerevent
        var %event = $did($dname,$did,1)
        var %new_sort_by = $gettok(%event,3,32)

        if ($hget(Q3SA.sort_data,fav_sort_column) == %new_sort_by) {
            if ($hget(Q3SA.sort_data,fav_sort_order_ $+ %new_sort_by) == asc) {
                Q3SA.load_favorites %new_sort_by desc
            }
            else {
                Q3SA.load_favorites %new_sort_by asc
            }
        }
        else {
            Q3SA.load_favorites %new_sort_by $hget(Q3SA.sort_data,fav_sort_order_ $+ %new_sort_by)
        }
    }
}

on 1:DIALOG:Q3SA.dialog:SCLICK:501,502: {
    if ($Q3SA.is_valid_address($did(Q3SA.dialog, 300))) {
        Q3SA.update_server $did(Q3SA.dialog, 300)
    }
}

on 1:DIALOG:Q3SA.dialog:SCLICK:504: {
    Q3SA.copy
}

on 1:DIALOG:Q3SA.dialog:SCLICK:507: {
    if ($did($dname,$did).state == 1) {
        Q3SA.q3connect
    }
    else {
        Q3SA.back
    }
}

on 1:DIALOG:Q3SA.dialog:SCLICK:550: {
    unset %Q3SA.*
    .remove $shortfn($scriptdir) $+ players_all.temp
    .remove $shortfn($scriptdir) $+ players_blue.temp
    .remove $shortfn($scriptdir) $+ players_red.temp
    .remove $shortfn($scriptdir) $+ players_spec.temp
}

on 1:DIALOG:Q3SA.dialog:SCLICK:580: {
    if ($did(Q3SA.dialog,580).state == 0) {
        Q3SA.remove_favorite $did($dname,300)
    }
    else {
        Q3SA.add_favorite
    }
}

ON 1:DIALOG:Q3SA.dialog:SCLICK:601: {
    var %column = $hget(Q3SA.sort_data,fav_sort_column)
    var %order = $hget(Q3SA.sort_data,fav_sort_order_ $+ %column)
    Q3SA.load_favorites %column %order $did(Q3SA.dialog,601).seltext
    if ((%Q3SA.current_group == <All>) || (%Q3SA.current_group == <Unassigned>)) {
        did -b Q3SA.dialog 1121,1122
    }
    elseif ($Q3SA.in_favorite_group($Q3SA.make_full_address($did(Q3SA.dialog,300)),%Q3SA.current_group)) {
        did -e Q3SA.dialog 1122
        did -b Q3SA.dialog 1121
    }
    else {
        did -e Q3SA.dialog 1121
        did -b Q3SA.dialog 1122
    }
}

ON 1:DIALOG:Q3SA.dialog:SCLICK:700,701,702,703: {
    did -h $dname 201,203,204,205
    if ($did == 700) {
        did -v $dname 201
        set %Q3SA.player_view All
    }
    elseif (%Q3SA.team_mode) {
        if ($did == 701) {
            did -v $dname 203
            set %Q3SA.player_view Blue
        }
        elseif ($did == 702) {
            did -v $dname 204
            set %Q3SA.player_view Red
        }
        elseif ($did == 703) {
            did -v $dname 205
            set %Q3SA.player_view Spec
        }
    }
    else {
        did -v $dname 201
        did -u $dname $did
        did -b $dname 701,702,703
        did -h $dname 203,204,205
        did -c $dname 700
    }
    Q3SA.refresh_playerlist
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Dialog MENU Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

on 1:DIALOG:Q3SA.dialog:MENU:503: {
    if ($did($dname,$did).state == 0) {
        did -c $dname $did
        .timerQ3SAMonitor 0 $readini(%Q3SA.ini,main,monitor_interval) Q3SA.monitor_tick
    }
    else {
        did -u $dname $did
        .timerQ3SAMonitor off
    }
}

on 1:DIALOG:Q3SA.dialog:MENU:506: {
    %result = $dialog(Q3SA.server_info_dialog, Q3SA.server_info_dialog,-4)
}

on 1:DIALOG:Q3SA.dialog:MENU:509: {
    Q3SA.add_favorite
}

on 1:DIALOG:Q3SA.dialog:MENU:510: {
    Q3SA.remove_favorite $did($dname,300)
}

on 1:DIALOG:Q3SA.dialog:MENU:511: {
    %result = $dialog(Q3SA.options_dialog, Q3SA.options_dialog,-4)
}

on 1:DIALOG:Q3SA.dialog:SCLICK:513: {
    Q3SA.copy report
}

ON 1:DIALOG:Q3SA.dialog:MENU:1103: {
    Q3SA.check_for_update
}

ON 1:DIALOG:Q3SA.dialog:MENU:1105: {
    dialog -c $dname
}

on 1:DIALOG:Q3SA.dialog:MENU:1111: {
    if ($did($dname,$did).state == 0) {
        Q3SA.q3connect
    }
    else {
        Q3SA.back
    }
}

on 1:DIALOG:Q3SA.dialog:MENU:1113: {
    if ($Q3SA.is_valid_address($did(Q3SA.dialog, 300))) {
        Q3SA.update_server $did(Q3SA.dialog, 300)
    }
}

on 1:DIALOG:Q3SA.dialog:MENU:1117: {
    Q3SA.copy
}

on 1:DIALOG:Q3SA.dialog:MENU:1118: {
    Q3SA.copy report
}

on 1:DIALOG:Q3SA.dialog:MENU:1121: {
    var %ip = $did(Q3SA.dialog,300)
    var %data = $readini(%Q3SA.ini,n,favorites,%ip)
    var %joins = $gettok(%data,1,92)
    var %name = $gettok(%data,2,92)
    var %groups = $gettok(%data,3,92)

    set %groups $addtok(%groups,%Q3SA.current_group,96)
    writeini -n %Q3SA.ini favorites %ip $infostring(%joins,%name,%groups)
    Q3SA.refresh_favorites
    did -b Q3SA.dialog 1121
    did -e Q3SA.dialog 1122
}

on 1:DIALOG:Q3SA.dialog:MENU:1122: {
    var %ip = $did(Q3SA.dialog,300)
    var %data = $readini(%Q3SA.ini,n,favorites,%ip)
    var %joins = $gettok(%data,1,92)
    var %name = $gettok(%data,2,92)
    var %groups = $gettok(%data,3,92)

    set %groups $remtok(%groups,%Q3SA.current_group,1,96)
    writeini -n %Q3SA.ini favorites %ip $infostring(%joins,%name,%groups)
    Q3SA.refresh_favorites
    did -b Q3SA.dialog 1122
    did -e Q3SA.dialog 1121
}

on 1:DIALOG:Q3SA.dialog:MENU:1135: {
    var %foo $input(Q3SA $Q3SA.version_text $+ $crlf $+ $crlf $+  Copyright 2001-2002 $+ $chr(44) Andy Uhl $+ $crlf $+ monk@demoxpress.com $+ $crlf, 68, About Q3SA)
}

on 1:DIALOG:Q3SA.dialog:MENU:1136: {
    var %foo $input(vPak 1.1 for mIRC 5.91 $+ $crlf $+ $crlf $+ Q3SA uses a slightly modified version of vPak by Variant <variant@variantrealities.com> $+ $crlf $+ vPak uses nGZIPn 1.0 by Necroman $+ $crlf, 68, About vPak)
}

on 1:DIALOG:Q3SA.dialog:MENU:1138: {
    window -aCk0do @License -1 -1 600 400 Courier New 12
    loadbuf -r @License $shortfn($scriptdir) $+ LICENSE
    sline @License 20
    renwin @License @Q3SA License
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Dialog EDIT Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.dialog:EDIT:300: {
    if ($Q3SA.is_valid_address($did(Q3SA.dialog,300))) {
        Q3SA.set_valid
    }
    else {
        Q3SA.set_invalid
    }
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Server Info Dialog Event Handlers ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.server_info_dialog:INIT:*: {
    mdx SetMircVersion $version
    mdx MarkDialog $dname
    mdx SetControlMDX $dname 200 listview single report rowselect nosortheader sortascending > $shortfn($scriptdir) $+ views.mdx
    did -i $dname 200 1 headerdims 120 238
    did -i $dname 200 1 headertext $tab(+l Variable,+l Value)

    var %info $right(%Q3SA.server_info,-1)
    var %name, %value
    var %lcv 0

    while (($numtok(%info,92) > 1) && (%lcv < 100)) {
        set %name $gettok(%info, 1, 92)
        set %value $gettok(%info, 2, 92)
        did -a Q3SA.server_info_dialog 200 $tab(+ 0 0 0 %name,+ 0 0 0 %value)
        set %info $deltok(%info,1-2,92)
        inc %lcv
    }
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Options Dialog Event Handlers ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.options_dialog:INIT:*: {
    var %lcv = 1

    mdx SetMircVersion $version
    mdx MarkDialog $dname

    didtok Q3SA.options_dialog 1 35 Copy and Paste#Groups#IRC#Miscellaneous#Quake 3 Setup
    did -c Q3SA.options_dialog 1 1
    Q3SA.load_options

    var %group_count = $ini(%Q3SA.ini, groups, 0)
    while (%lcv <= %group_count) {
        did -a $dname 501 $ini(%Q3SA.ini,groups,%lcv)
        inc %lcv
    }
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Options Dialog SCLICK Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:1: {
    did -h Q3SA.options_dialog 100,101,102,103,104,105,106,107
    did -h Q3SA.options_dialog 200,201,202,203,204,205,206,207,208,209,210,211,212
    did -h Q3SA.options_dialog 300,301,302,303,304,305,306,307,308,309,310
    did -h Q3SA.options_dialog 400,401,402,403,404,405,406
    did -h Q3SA.options_dialog 500,501,502,503
    ;did -h Q3SA.options_dialog 901,902
    ;did -h Q3SA.options_dialog 1000,1001,1002

    var %page = $did(Q3SA.options_dialog,1).sel
    ; Copy and Paste
    if (%page == 1) {
        did -v Q3SA.options_dialog 400,401,402,403,404,405,406
    }
    elseif (%page == 2) {
        did -v Q3SA.options_dialog 500,501,502,503
    }
    ; IRC
    elseif (%page == 3) {
        did -v Q3SA.options_dialog 100,101,102,103,104,105,106,107
    }
    ; Miscellaneous
    elseif (%page == 4) {
        did -v Q3SA.options_dialog 200,201,202,203,204,205,206,207,208,209,210,211,212
    }
    ; Quake 3 Setup
    elseif (%page == 5) {
        did -v Q3SA.options_dialog 300,301,302,303,304,305,306,307,308,309,310
    }
    ; About
    ;elseif (%page == 6) {
    ;    did -v Q3SA.options_dialog 901,902
    ;}
    ; License
    ;elseif (%page == 7) {
    ;    did -v Q3SA.options_dialog 1000,1001,1002
    ;}
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:2: {
    Q3SA.save_options
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:4: {
    Q3SA.save_options
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:101: {
    did -e Q3SA.options_dialog 4
    if ($did(Q3SA.options_dialog,101).state == 0) { did -m Q3SA.options_dialog 102 }
    else { did -n Q3SA.options_dialog 102 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:103: {
    did -e Q3SA.options_dialog 4
    if ($did(Q3SA.options_dialog,103).state == 0) { did -m Q3SA.options_dialog 104 }
    else { did -n Q3SA.options_dialog 104 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:105: {
    did -e Q3SA.options_dialog 4
    if ($did(Q3SA.options_dialog,105).state == 0) { did -m Q3SA.options_dialog 106 }
    else { did -n Q3SA.options_dialog 106 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:303: {
    var %exe
    set %exe $sfile($mircdir,Quake 3 Executable)
    if (%exe != $null) {
        did -ra Q3SA.options_dialog 302 %exe
        did -e Q3SA.options_dialog 4
    }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:304: {
    did -e Q3SA.options_dialog 4
    if ($did(Q3SA.options_dialog,304).state == 0) { did -m Q3SA.options_dialog 305 | did -b Q3SA.options_dialog 306 }
    else { did -n Q3SA.options_dialog 305 | did -e Q3SA.options_dialog 306 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:306: {
    var %exe
    set %exe $sfile($mircdir,Execute config file)
    if (%exe != $null) {
        did -ra Q3SA.options_dialog 305 %exe
        did -e Q3SA.options_dialog 4
    }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:307: {
    did -e Q3SA.options_dialog 4
    if ($did(Q3SA.options_dialog,307).state == 0) { did -m Q3SA.options_dialog 308 }
    else { did -n Q3SA.options_dialog 308 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:309: {
    did -e Q3SA.options_dialog 4
    if ($did(Q3SA.options_dialog,309).state == 0) { did -m Q3SA.options_dialog 310 }
    else { did -n Q3SA.options_dialog 310 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:401,402,403,404,406: {
    did -e Q3SA.options_dialog 4
    if ($did == 404) { did -n Q3SA.options_dialog 405 }
    else { did -m Q3SA.options_dialog 405 }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:501: {
    return
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:502: {
    var %group_name = $input(What group do you want to create?,165,New Group)

    if (%group_name != $null) {
        if ($count(%group_name,`) > 0) {
            var %foo = $input(Group names cannot contain the backtick (`) character.,1,Illegal Character)
        }
        elseif ($count(%group_name,$chr(9)) > 0) {
            var %foo = $input(Group names cannot contain the tab character.,4,Illegal Character)
        }
        elseif (($count(%group_name,<) > 0) || ($count(%group_name,>) > 0)) {
            var %foo = $input(Group names cannot contain the angled brace characters. (<>),4,Illegal Character)
        }
        else {
            if ($ini(%Q3SA.ini,groups,%group_name) == 0) {
                did -a $dname 501 %group_name
            }
            else {
                ; group already exists
                var %foo = $input(That group already exists!,4,Duplicate Group)
            }
        }
    }
}

ON 1:DIALOG:Q3SA.options_dialog:SCLICK:503: {
    ;var %group_name = $gettok($did($dname,501).seltext,6-,32)
    var %group_name = $did($dname,501).seltext

    if ($input(Do you really want to delete the ' $+ %group_name $+ ' group?,296,Delete Group) == $yes) {
        ;remini %Q3SA.ini groups %group_name
        did -d $dname 501 $did($dname,501).sel
    }
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Options Dialog catch all event ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.options_dialog:EDIT,SCLICK:*: {
    if ($did != 0) { did -e Q3SA.options_dialog 4 }
}

;;;;;;;;;;;;;;;;;;;;;;;;;
;; Other Dialog Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;

ON 1:DIALOG:Q3SA.join_dialog:SCLICK:500: {
    did -ra Q3SA.join_dialog 301 1
}

ON 1:DIALOG:Q3SA.join_dialog:SCLICK:501: {
    did -ra Q3SA.join_dialog 301 0
}

ON 1:DIALOG:Q3SA.priority_dialog:SCLICK:500: {
    did -ra Q3SA.priority_dialog 301 1
}

ON 1:DIALOG:Q3SA.priority_dialog:SCLICK:501: {
    did -ra Q3SA.priority_dialog 301 0
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Download Dialog Event Handlers ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

on 1:DIALOG:Q3SA.download_dialog:INIT:*: {
    mdx SetMircVersion $version
    mdx MarkDialog $dname
    ;mdx SetControlMDX $dname 1 animation center transparent > $shortfn($scriptdir) $+ ctl_gen.mdx
    ;mdx SetControlMDX $dname 2 progressbar > $shortfn($scriptdir) $+ ctl_gen.mdx
    mdx SetControlMDX $dname 1 animation center transparent > $shortfn($scriptdir) $+ ctl_gen.mdx
    mdx SetControlMDX $dname 5 progressbar > $shortfn($scriptdir) $+ ctl_gen.mdx

    ;did -a $dname 1 open $shortfn($scriptdir) $+ download.avi
    ;did -a $dname 1 play
    set %Q3SA.download.canceled $false
    set %Q3SA.download.stage 0
}

on 1:DIALOG:Q3SA.download_dialog:SCLICK:14: {
    .sockclose Q3SA_download
    set %Q3SA.download.canceled $true
    .remove %Q3SA.vpak_filename
}

on 1:DIALOG:Q3SA.download_dialog:SCLICK:15: {
    .dialog -k $dname
    Q3SA.upgrade_Q3SA
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Socket Read Event and Aliases for Processing ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

alias -l Q3SA.process_player_line {
    inc %Q3SA.svar.playercount
    var %Q3SA.frags = $base($gettok($1-,1,32),10,10,4)
    var %Q3SA.ping = $base($gettok($1-,2,32),10,10,4)
    var %Q3SA.name = $Q3SA.strip_colors($gettok($1-,2,34))

    if (%Q3SA.debug > 2) { echo -s %Q3SA.svar.playercount => %Q3SA.name }
    write %Q3SA.players_fn $tab(%Q3SA.frags,%Q3SA.ping,%Q3SA.name)

    if (%Q3SA.team_mode) {
        if ($istok(%Q3SA.svar.players_blue,%Q3SA.svar.playercount,32)) {
            inc %Q3SA.svar.blue_playercount
            write %Q3SA.blue_fn $tab(%Q3SA.frags,%Q3SA.ping,%Q3SA.name)
        }
        elseif ($istok(%Q3SA.svar.players_red,%Q3SA.svar.playercount,32)) {
            inc %Q3SA.svar.red_playercount
            write %Q3SA.red_fn $tab(%Q3SA.frags,%Q3SA.ping,%Q3SA.name)
        }
        else {
            inc %Q3SA.svar.spec_playercount
            write %Q3SA.spec_fn $tab(%Q3SA.frags,%Q3SA.ping,%Q3SA.name)
        }
    }
}

alias -l Q3SA.process_svars {
    var %last_token = 0
    var %total_tokens = $numtok($1-, 92)

    set %Q3SA.server_info $1-
    set %Q3SA.svar.server_ip $did(Q3SA.dialog,300)

    ; loop through each token and create a server variable for it
    while (%last_token < %total_tokens) {
        inc %last_token
        set %Q3SA.svar. [ $+ [ $replace($lower($gettok($1-,%last_token,92)),$chr(32),_) ] ] $gettok(%Q3SA.data, $calc(%last_token + 1), 92)
        inc %last_token
    }

    ; if a publicclients svar doesn't exist already, calc one and save it
    if ($var(%Q3SA.svar.publicclients,0) == 0) {
        set %Q3SA.svar.publicclients $calc(%Q3SA.svar.sv_maxclients - %Q3SA.svar.sv_privateclients)
    }

    set %Q3SA.svar.private $iif(%Q3SA.svar.g_needpass == 1,Yes,No)
    set %Q3SA.team_mode $iif(($var(%Q3SA.svar.players_blue,0) == 1) && ($var(%Q3SA.svar.players_red,0) == 1),$true,$false)
}

alias -l Q3SA.set_gametype {
    if (%Q3SA.svar.gamename == threewave) {
        if (%Q3SA.svar.g_gametype == 10) { set %Q3SA.svar.gametype Classic CTF }
        elseif (%Q3SA.svar.g_gametype == 9) { set %Q3SA.svar.gametype CaptureStrike }
        elseif (%Q3SA.svar.g_gametype == 8) { set %Q3SA.svar.gametype Portal }
        elseif (%Q3SA.svar.g_gametype == 7) { set %Q3SA.svar.gametype Harvester }
        elseif (%Q3SA.svar.g_gametype == 6) { set %Q3SA.svar.gametype Overload }
        elseif (%Q3SA.svar.g_gametype == 5) { set %Q3SA.svar.gametype One Flag }
        elseif (%Q3SA.svar.g_gametype == 4) { set %Q3SA.svar.gametype Capture the Flag }
        elseif (%Q3SA.svar.g_gametype == 3) { set %Q3SA.svar.gametype Team Deathmatch }
        elseif (%Q3SA.svar.g_gametype == 2) { set %Q3SA.svar.gametype Single Player }
        elseif (%Q3SA.svar.g_gametype == 1) { set %Q3SA.svar.gametype 1v1 Tournament }
        elseif (%Q3SA.svar.g_gametype == 0) { set %Q3SA.svar.gametype FFA }
        else { set %Q3SA.svar.gametype Unknown }
    }
    elseif (%Q3SA.svar.gamename == osp) {
        if (%Q3SA.svar.g_gametype == 5) { set %Q3SA.svar.gametype Clan Arena }
        elseif (%Q3SA.svar.g_gametype == 4) { set %Q3SA.svar.gametype Capture the Flag }
        elseif (%Q3SA.svar.g_gametype == 3) { set %Q3SA.svar.gametype Team Deathmatch }
        elseif (%Q3SA.svar.g_gametype == 2) { set %Q3SA.svar.gametype Single Player }
        elseif (%Q3SA.svar.g_gametype == 1) { set %Q3SA.svar.gametype 1v1 Tournament }
        elseif (%Q3SA.svar.g_gametype == 0) { set %Q3SA.svar.gametype FFA }
        else { set %Q3SA.svar.gametype Unknown }
    }
    elseif (%Q3SA.svar.gamename == baseq3) {
        if (%Q3SA.svar.g_gametype == 7) { set %Q3SA.svar.gametype Harvester }
        elseif (%Q3SA.svar.g_gametype == 6) { set %Q3SA.svar.gametype Overload }
        elseif (%Q3SA.svar.g_gametype == 5) { set %Q3SA.svar.gametype One Flag }
        elseif (%Q3SA.svar.g_gametype == 4) { set %Q3SA.svar.gametype Capture the Flag }
        elseif (%Q3SA.svar.g_gametype == 3) { set %Q3SA.svar.gametype Team Deathmatch }
        elseif (%Q3SA.svar.g_gametype == 2) { set %Q3SA.svar.gametype Single Player }
        elseif (%Q3SA.svar.g_gametype == 1) { set %Q3SA.svar.gametype 1v1 Tournament }
        elseif (%Q3SA.svar.g_gametype == 0) { set %Q3SA.svar.gametype FFA }
        else { set %Q3SA.svar.gametype Unknown }
    }
    else {
        if (%Q3SA.svar.g_gametype == 4) { set %Q3SA.svar.gametype Capture the Flag }
        elseif (%Q3SA.svar.g_gametype == 3) { set %Q3SA.svar.gametype Team Deathmatch }
        elseif (%Q3SA.svar.g_gametype == 2) { set %Q3SA.svar.gametype Single Player }
        elseif (%Q3SA.svar.g_gametype == 1) { set %Q3SA.svar.gametype 1v1 Tournament }
        elseif (%Q3SA.svar.g_gametype == 0) {  }
        else { set %Q3SA.svar.gametype Unknown }
    }

    did -ra Q3SA.dialog 305 %Q3SA.svar.gametype
}

alias -l Q3SA.update_display {
    var %time_text = Time: ?
    var %red_score = Red: ?
    var %blue_score = Blue: ?

    Q3SA.set_gametype

    did -ra Q3SA.dialog 312 %Q3SA.svar.private

    ; update the dialog with our newly received information
    did -ra Q3SA.dialog 301 %Q3SA.svar.sv_hostname
    did -ra Q3SA.dialog 304 %Q3SA.svar.mapname
    did -ra Q3SA.dialog 306 %Q3SA.svar.timelimit / %Q3SA.svar.fraglimit / %Q3SA.svar.capturelimit
    did -ra Q3SA.dialog 307 %Q3SA.svar.gamename

    if ($Q3SA.is_favorite($did(Q3SA.dialog,300))) {
        var %fav_line = $did(Q3SA.dialog,202).seltext
        var %join_line = $gettok(%fav_line,1,9)
        var %name_line = $gettok(%fav_line,2,9)
        var %group_line = $gettok(%fav_line,3,9)
        if ($gettok(%name_line,5-,32) != $did(Q3SA.dialog,301)) {
            var %ini_line = $readini(%Q3SA.ini,n,favorites,$did(Q3SA.dialog,300))
            writeini %Q3SA.ini favorites $did(Q3SA.dialog,300) $infostring($gettok(%join_line,6,32),$did(Q3SA.dialog,301),$gettok(%ini_line,3,92))
            did -o Q3SA.dialog 202 $did(Q3SA.dialog,202).sel $tab(%join_line,$gettok(%name_line,1-4,32) $did(Q3SA.dialog,301),$did(Q3SA.dialog,300))
        }
    }

    if (%Q3SA.team_mode) {
        did -e Q3SA.dialog 700,701,702,703
    }
    else {
        did -bu Q3SA.dialog 701,702,703
        did -ce Q3SA.dialog 700
        did -h Q3SA.dialog 203,204,205
        did -v Q3SA.dialog 201
    }

    if ($var(%Q3SA.svar.score_time,0) == 1) { set %time_text Time: %Q3SA.svar.score_time }
    if ($var(%Q3SA.svar.score_blue,0) == 1) { set %blue_score Blue: %Q3SA.svar.score_blue }
    if ($var(%Q3SA.svar.score_red,0) == 1) { set %red_score Red: %Q3SA.svar.score_red }

    did -ra Q3SA.dialog 310 %time_text / %blue_score / %red_score

    did -ra Q3SA.dialog 309 $replace($did(Q3SA.dialog,309),*,%Q3SA.svar.playercount)
    did -ra Q3SA.dialog 309 %Q3SA.svar.playercount / %Q3SA.svar.sv_privateClients / %Q3SA.svar.sv_maxclients

}

on *:UDPREAD:Q3SA: {
    if ($dialog(Q3SA.dialog) == $null) { halt }

    unset %Q3SA.svar.*

    set %Q3SA.svar.playercount 0
    set %Q3SA.svar.blue_playercount 0
    set %Q3SA.svar.red_playercount 0
    set %Q3SA.svar.spec_playercount 0

    .remove %Q3SA.players_fn
    .remove %Q3SA.blue_fn
    .remove %Q3SA.red_fn
    .remove %Q3SA.spec_fn

    did -r Q3SA.dialog 201,203,204,205

    sockread %Q3SA.data

    while ($sockbr > 0) {
        if (%Q3SA.debug > 1) { echo -s %Q3SA.data }
        ; if it's the first line of a status response
        if (%Q3SA.data == statusResponse) {
            ; we didn't time out
            .timerQ3SATimeout off
            ; calculate our ping
            set %Q3SA.svar.ping $calc($ticks - %Q3SA.udp_out)
            ; update the dialog
            did -ra Q3SA.dialog 303 %Q3SA.svar.ping
            did -ra Q3SA.dialog 309 0
            did -e Q3SA.dialog 504,506,513,1117,1118
        }
        ; we've started receiving the infostring formatted information
        elseif ($left(%Q3SA.data, 1) == $chr(92)) {
            Q3SA.process_svars %Q3SA.data
        }
        ; we're receiving player information
        elseif ($gettok(%Q3SA.data,1,32) isnum) {
            Q3SA.process_player_line %Q3SA.data
        }

        ; read in another line of data
        sockread %Q3SA.data
    }

    sockclose Q3SA

    Q3SA.update_display
    Q3SA.refresh_playerlist
    Q3SA.load_passwords
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Version Check Socket Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

on *:SOCKOPEN:Q3SA_version: {
    if ($sockerr > 0) { echo -s Socket error: $sockerr (1) }

    echo -s Contacting q3sa.gamedaemon.com...
    sockwrite -n $sockname GET /current_version HTTP/1.0
    sockwrite -n $sockname Accept: */*
    sockwrite -n $sockname Host: q3sa.gamedaemon.com
    sockwrite -n $sockname
}

on *:SOCKREAD:Q3SA_version: {
    if ($sockerr > 0) { echo -s Socket error: $sockerr (2) }

    echo -s Receiving version information...
    sockread %temp
    while ($sockbr) {
        if (%temp == $null) { break }
        sockread %temp
    }

    while ($sockbr) {
        sockread %temp
        if (Version: * iswm %temp) {
            set %Q3SA.newest_version $gettok(%temp,-1,32)
        }
        elseif (vPak: * iswm %temp) {
            set %Q3SA.vpak_filename $gettok(%temp,-1,32)
        }
        elseif (Zip: * iswm %temp) {
            set %Q3SA.zip_filename $gettok(%temp,-1,32)
        }
    }

    Q3SA.update_available
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Download Update Socket Events ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

on *:SOCKOPEN:Q3SA_download: {
    if ($sockerr > 0) { echo -s Socket error: $sockerr (1) }

    write -c %Q3SA.vpak_filename
    unset %Q3SA.download.length
    set %Q3SA.download.stage 1
    set %Q3SA.download.canceled $false

    sockwrite -n $sockname GET / $+ %Q3SA.vpak_filename HTTP/1.0
    sockwrite -n $sockname Accept: */*
    sockwrite -n $sockname Host: q3sa.gamedaemon.com
    sockwrite -n $sockname
}

on *:SOCKREAD:Q3SA_download: {
    if ($sockerr > 0) { echo -s Socket error: $sockerr (2) }

    if (%Q3SA.download.stage == 1) {
        .dialog -dram Q3SA.download_dialog Q3SA.download_dialog
        did -ra Q3SA.download_dialog 4 %Q3SA.vpak_filename from q3sa.gamedaemon.com
        did -ra Q3SA.download_dialog 10 $scriptdir
        did -a Q3SA.download_dialog 1 open $shortfn($scriptdir) $+ download.avi
        did -a Q3SA.download_dialog 1 play
        set %Q3SA.downloading $true
        set %Q3SA.download.last_update 0
        sockread %header
        while ($sockbr) {
            if (Content-length: * iswm %header) {
                set %Q3SA.download.size $gettok(%header,2,32)
                did -ra Q3SA.download_dialog 12 $Q3SA.format_filesize(%Q3SA.download.size)
                did -a Q3SA.download_dialog 5 0 0 %Q3SA.download.size
            }
            elseif (%header == $null) {
                set %Q3SA.download.size_offset $sock($sockname).rcvd
                set %Q3SA.download.time_offset $sock($sockname).to
                set %Q3SA.download.stage 2
                break
            }
            sockread %header
        }
    }

    if (%Q3SA.download.stage == 2) {
        ; begin binary download
        sockread &data
        while ($sockbr) {
            if ($sockerr > 0) { echo -s Socket error: $sockerr (2) }

            if ($calc($ticks - %Q3SA.download.last_update) > 1000) {
                set %Q3SA.download.bytes_received $calc($sock($sockname).rcvd - %Q3SA.download.size_offset)
                set %Q3SA.download.time $sock($sockname).to - %Q3SA.download.time_offset
                set %Q3SA.download.last_update $ticks
                did -a Q3SA.download_dialog 5 %Q3SA.download.bytes_received
                did -ra Q3SA.download_dialog 12 $Q3SA.format_filesize(%Q3SA.download.bytes_received) / $Q3SA.format_filesize(%Q3SA.download.size)
                did -ra Q3SA.download_dialog 13 $Q3SA.format_filesize($calc(%Q3SA.download.bytes_received / %Q3SA.download.time)) $+ /sec.
                did -ra Q3SA.download_dialog 11 $duration($round($calc((%Q3SA.download.size - %Q3SA.download.bytes_received) / (%Q3SA.download.bytes_received / %Q3SA.download.time)),0))
                .dialog -t Q3SA.download_dialog $round($calc(100 * (%Q3SA.download.bytes_received / %Q3SA.download.size)),0) $+ % of %Q3SA.vpak_filename Completed
            }

            bwrite %Q3SA.vpak_filename -1 -1 &data
            sockread &data
        }
    }
}

on 1:SOCKCLOSE:Q3SA_download: {
    if (%Q3SA.downloading && (!%Q3SA.download.canceled)) {
        did -a Q3SA.download_dialog 1 stop
        did -a Q3SA.download_dialog 1 seek 1
        .dialog -t Q3SA.download_dialog Download Complete
        did -ev Q3SA.download_dialog 15,16
        did -h Q3SA.download_dialog 14
        did -ra Q3SA.download_dialog 7 Elapsed Time:
        did -ra Q3SA.download_dialog 11 $duration(%Q3SA.download.time)
        did -ra Q3SA.download_dialog 12 $Q3SA.format_filesize(%Q3SA.download.size)
        set %Q3SA.downloading $false
    }
}

;;;;;;;;;;;
;; Other ;;
;;;;;;;;;;;

CTCP *:VERSION:*: {
    if ($readini(%Q3SA.ini,n,main,version_reply) == 1) {
        .ctcpreply $nick VERSION Q3SA $Q3SA.version_text by Andy Uhl - http://q3sa.gamedaemon.com/
    }
}

on *:hotlink:*.*.*.*:*: {
    if (($gettok($1,1,46) isnum 0-255) && ($gettok($1,2,46) isnum 0-255) && ($gettok($1,3,46) isnum 0-255)) {
        if (($gettok($gettok($1,1,58),4,46) isnum 0-255) && ($gettok($1,2,58) isnum 0-65000)) {
            if ($dialog(Q3SA.dialog) == $null) { Q3SA.start }
            did -ra Q3SA.dialog 300 $1
            if ($Q3SA.is_valid_address($did(Q3SA.dialog, 300))) { Q3SA.update_server $did(Q3SA.dialog, 300) }
        }
    }
}

on ^*:HOTLINK:*.*.*.*:*: {
    if (($gettok($1,1,46) isnum 0-255) && ($gettok($1,2,46) isnum 0-255) && ($gettok($1,3,46) isnum 0-255)) {
        if (($gettok($gettok($1,1,58),4,46) isnum 0-255) && ($gettok($1,2,58) isnum 0-65000)) {
            return
        }
    }
    halt
}

